package com.sinosig.core.module.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import com.sinosig.core.module.domain.JQXTBYD;
import com.sinosig.core.module.filter.JQXTBYDSearchContext;
import com.sinosig.core.module.service.IJQXTBYDService;
import com.sinosig.core.module.service.logic.IJQXTBYDGetTBYDKXXLogic;
import org.springframework.beans.factory.annotation.Autowired;
import com.sinosig.util.SearchResult;

/**
 * 实体[JQXTBYD] 服务对象接口实现
 */
@Service
public class JQXTBYDServiceImpl implements IJQXTBYDService {

    @Autowired
    com.sinosig.core.repository.JQXTBYDRepository jQXTBYDRepository;



    @Autowired
    private IJQXTBYDGetTBYDKXXLogic gettbydkxxLogic ;


    @Override
    public boolean checkKey(JQXTBYD jqxtbyd) {
        return true;
    }
    @Override
    public boolean create(JQXTBYD jqxtbyd) {
        boolean bOk = false ;
        com.sinosig.core.repository.po.JQXTBYD t_JQXTBYD = jQXTBYDRepository.convert2PO(jqxtbyd,null);
        bOk = jQXTBYDRepository.create(t_JQXTBYD);
        jQXTBYDRepository.convert2Domain(t_JQXTBYD,jqxtbyd);

        return bOk ;
    }

    @Override
    public JQXTBYD getDraftTemp(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    @Override
    public JQXTBYD getTBYDKXX(JQXTBYD jqxtbyd) {
         gettbydkxxLogic.execute(jqxtbyd);
         return jqxtbyd ;
    }
    @Override
    public JQXTBYD createTemp(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    @Override
    public JQXTBYD getTemp(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    @Override
    public JQXTBYD removeTemp(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    @Override
    public boolean save(JQXTBYD jqxtbyd) {
        if(jqxtbyd.getJQXTBYDId()==null){
    		return create(jqxtbyd);
    	}else{
            if(this.get(jqxtbyd.getJQXTBYDId())!=null){
    			return update(jqxtbyd);
    		}
    		return create(jqxtbyd);
    	}
    }

    @Override
    public boolean remove(String jqxtbydid) {
        boolean bOk = false ;
        bOk = jQXTBYDRepository.remove(jqxtbydid);

        return bOk ;
    }

    @Override
    public JQXTBYD get(String jqxtbydid) {
        com.sinosig.core.repository.po.JQXTBYD t_JQXTBYD = jQXTBYDRepository.get(jqxtbydid);
        return jQXTBYDRepository.convert2Domain(t_JQXTBYD,null);
    }

    @Override
    public JQXTBYD get(JQXTBYD jqxtbyd) {
        com.sinosig.core.repository.po.JQXTBYD t_JQXTBYD = jQXTBYDRepository.get(jqxtbyd.getJQXTBYDId());
        jQXTBYDRepository.convert2Domain(t_JQXTBYD,jqxtbyd);
        return jqxtbyd;
    }

    @Override
    public JQXTBYD removeTempMajor(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    @Override
    public JQXTBYD updateTemp(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    @Override
    public JQXTBYD updateTempMajor(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    @Override
    public boolean update(JQXTBYD jqxtbyd) {
        boolean bOk = false ;
        com.sinosig.core.repository.po.JQXTBYD t_JQXTBYD = jQXTBYDRepository.convert2PO(jqxtbyd,null);
        bOk = jQXTBYDRepository.update(t_JQXTBYD);
        jQXTBYDRepository.convert2Domain(t_JQXTBYD,jqxtbyd) ;

        return bOk ;
    }

    @Override
    public JQXTBYD getDraftTempMajor(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    @Override
    public JQXTBYD getTempMajor(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    @Override
    public JQXTBYD getDraft(JQXTBYD jqxtbyd) {
        return jqxtbyd;
    }

    @Override
    public JQXTBYD createTempMajor(JQXTBYD jqxtbyd) {
         return jqxtbyd;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<JQXTBYD> searchDefault(JQXTBYDSearchContext context) {
        List<JQXTBYD> list = new ArrayList<JQXTBYD>();
        Page<com.sinosig.core.repository.po.JQXTBYD> t_JQXTBYDs = jQXTBYDRepository.searchDefault(context) ;
        for(com.sinosig.core.repository.po.JQXTBYD t_JQXTBYD : t_JQXTBYDs){
            list.add(jQXTBYDRepository.convert2Domain(t_JQXTBYD,null));
        }
        return new PageImpl<JQXTBYD>(list, context.getPageable(), t_JQXTBYDs.getTotalElements());
    }


    /**
     * 根据车险单查询
     */
    @Override
    public Page<JQXTBYD> selectByCID(String cidid ){
        JQXTBYDSearchContext context = new JQXTBYDSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(cidid)){
            com.sinosig.util.SearchFieldFilter fieldFilter=new com.sinosig.util.SearchFieldFilter();
            fieldFilter.setParam("cidid");
            fieldFilter.setCondition(com.sinosig.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(cidid);
            context.getCondition().add(fieldFilter);
        }
        List<JQXTBYD> list = new ArrayList<JQXTBYD>();
        Page<com.sinosig.core.repository.po.JQXTBYD> t_JQXTBYDs = jQXTBYDRepository.searchDefault(context) ;
        for(com.sinosig.core.repository.po.JQXTBYD t_JQXTBYD : t_JQXTBYDs){
            list.add(jQXTBYDRepository.convert2Domain(t_JQXTBYD,null));
        }
        return new PageImpl<JQXTBYD>(list, context.getPageable(), t_JQXTBYDs.getTotalElements());
    }

    /**
     * 根据车险单查询
     */
    @Override
    public List<JQXTBYD> selectByCID2(String cidid ){

        JQXTBYDSearchContext context = new JQXTBYDSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(cidid)){
            com.sinosig.util.SearchFieldFilter fieldFilter=new com.sinosig.util.SearchFieldFilter();
            fieldFilter.setParam("cidid");
            fieldFilter.setCondition(com.sinosig.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(cidid);
            context.getCondition().add(fieldFilter);
        }
        List<JQXTBYD> list = new ArrayList<JQXTBYD>();
        Page<com.sinosig.core.repository.po.JQXTBYD> t_JQXTBYDs = jQXTBYDRepository.searchDefault(context) ;
        for(com.sinosig.core.repository.po.JQXTBYD t_JQXTBYD : t_JQXTBYDs){
            list.add(jQXTBYDRepository.convert2Domain(t_JQXTBYD,null));
        }
        return list;
    }
    /**
     * 根据特别约定库查询
     */
    @Override
    public Page<JQXTBYD> selectByTBYDK(String tbydkid ){
        JQXTBYDSearchContext context = new JQXTBYDSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(tbydkid)){
            com.sinosig.util.SearchFieldFilter fieldFilter=new com.sinosig.util.SearchFieldFilter();
            fieldFilter.setParam("tbydkid");
            fieldFilter.setCondition(com.sinosig.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(tbydkid);
            context.getCondition().add(fieldFilter);
        }
        List<JQXTBYD> list = new ArrayList<JQXTBYD>();
        Page<com.sinosig.core.repository.po.JQXTBYD> t_JQXTBYDs = jQXTBYDRepository.searchDefault(context) ;
        for(com.sinosig.core.repository.po.JQXTBYD t_JQXTBYD : t_JQXTBYDs){
            list.add(jQXTBYDRepository.convert2Domain(t_JQXTBYD,null));
        }
        return new PageImpl<JQXTBYD>(list, context.getPageable(), t_JQXTBYDs.getTotalElements());
    }

    /**
     * 根据特别约定库查询
     */
    @Override
    public List<JQXTBYD> selectByTBYDK2(String tbydkid ){

        JQXTBYDSearchContext context = new JQXTBYDSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(tbydkid)){
            com.sinosig.util.SearchFieldFilter fieldFilter=new com.sinosig.util.SearchFieldFilter();
            fieldFilter.setParam("tbydkid");
            fieldFilter.setCondition(com.sinosig.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(tbydkid);
            context.getCondition().add(fieldFilter);
        }
        List<JQXTBYD> list = new ArrayList<JQXTBYD>();
        Page<com.sinosig.core.repository.po.JQXTBYD> t_JQXTBYDs = jQXTBYDRepository.searchDefault(context) ;
        for(com.sinosig.core.repository.po.JQXTBYD t_JQXTBYD : t_JQXTBYDs){
            list.add(jQXTBYDRepository.convert2Domain(t_JQXTBYD,null));
        }
        return list;
    }



}
